unit OptDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Spin, BrowseDr, XDLTreeView, uRegComp;

type
  TOptionsForm = class(TForm)
    ButtonHelp: TButton;
    ButtonCancel: TButton;
    ButtonOk: TButton;
    ButtonDefault: TButton;
    OptPageControl: TPageControl;
    TabSheetAffichage: TTabSheet;
    GroupBox1: TGroupBox;
    CheckBoxDetail: TCheckBox;
    CheckBoxIcon: TCheckBox;
    TabSheetClean: TTabSheet;
    GroupBox2: TGroupBox;
    CheckBoxSendToTrash: TCheckBox;
    CheckBoxConfirme: TCheckBox;
    CheckBoxTest: TCheckBox;
    CheckBoxCleanTrash: TCheckBox;
    CheckBoxCleanTemp: TCheckBox;
    StaticTextTempDir: TStaticText;
    CheckBoxPerso: TCheckBox;
    Bevel1: TBevel;
    TabSheetLog: TTabSheet;
    GroupBox3: TGroupBox;
    CheckBoxActiveLog: TCheckBox;
    Bevel2: TBevel;
    Label1: TLabel;
    StaticTextFileName: TStaticText;
    ButtonBrownsLog: TButton;
    Label2: TLabel;
    CheckBoxTime: TCheckBox;
    CheckBoxSize: TCheckBox;
    CheckBoxFile: TCheckBox;
    CheckBoxWarning: TCheckBox;
    CheckBoxError: TCheckBox;
    CheckBoxErase: TCheckBox;
    LabelSize: TLabel;
    RichEditLog: TRichEdit;
    TabSheetPerso: TTabSheet;
    TabSheetService: TTabSheet;
    Label3: TLabel;
    SpinEditRefreshProgress: TSpinEdit;
    ButtonDelLog: TButton;
    BrowseLogDlg: TBrowseDirectoryDlg;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    CheckBoxServiceStart: TCheckBox;
    RadioGroupClean: TRadioGroup;
    SpinEditTime: TSpinEdit;
    SpinEditSize: TSpinEdit;
    XDLTreeView: TXDLTreeView;
    ButtonAdd: TButton;
    ButtonEdit: TButton;
    ButtonDelete: TButton;
    LabelInfo: TLabel;
    Label4: TLabel;
    TabSheetInfo: TTabSheet;
    LabelInfos: TLabel;
    RadioGroupConfirm: TRadioGroup;
    procedure CheckBoxPersoClick(Sender: TObject);
    procedure CheckBoxActiveLogClick(Sender: TObject);
    procedure ButtonBrownsLogClick(Sender: TObject);
    procedure ButtonDelLogClick(Sender: TObject);
    procedure XDLTreeViewChange(Sender: TObject);
    procedure OptPageControlChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonDefaultClick(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonEditClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
  private
    { Private declarations }
    FLogDirName: string;
    FRegistry  : TXDELRegistry;
    procedure setLogDirName(Value: string);
    function getLogFileName: string;
  public
    { Public declarations }
    procedure MiseAJour;
    procedure reMiseAJour;

    procedure DlgInitialization;
    property LogDirName : string read FLogDirName write setLogDirName;
    property LogFileName: string read getLogFileName;
  end;

var
  OptionsForm: TOptionsForm;

function OpenOptionsBox(parent: HWnd): boolean; export;

implementation

{$R *.DFM}

uses uWindows, uDiskUtils, Registry, Algo, MaskDlg, uSearch;

resourcestring
  rsInfos       = 'Nom de l''application'#9':'#9'%s'#10#13 +
                  'Numro de version' +  #9':'#9'%s'#10#13 +
                  'Version courante' + #9':'#9'%s'#10#13 +
                  #10#13                             +
                  'Compagnie'   +      #9#9':'#9'%s'#10#13 +
                  'Premier dmarrage' +  #9':'#9'%d'#10#13;
  rsServiceText = 'En continue toutes les %d secondes'#10 +
                  'Si l''espace disque descend en dessous de %s';

  LogFileSize   = 'Taille du fichier: %s';

  AffDirInfo    = 'Dossier : "%s"'#10#13#10#13'%d Masque(s)';
  AffMskInfo    = 'Masque  : "%s"'#10#13#10#13'Mode %s';
  ModeRecursif  = 'Recursif';
  ModeStatic    = 'Static';

function OpenOptionsBox(parent: HWnd): boolean;
begin
  OptionsForm := TOptionsForm.CreateParented(parent);
  with OptionsForm do
  begin
    OptPageControl.ActivePage := TabSheetAffichage;
    FRegistry.LoadFromRegistry;
    MiseAJour;
    DlgInitialization;

    result := ShowModal = mrOk;
    if result then
    begin
      reMiseAJour;
      FRegistry.SaveToRegistry;
    end;
    Free;
  end;
end;

function TOptionsForm.getLogFileName: string;
begin
  Result := NormalDir(LogDirName) + rsLogFileName;
end;

procedure TOptionsForm.setLogDirName(Value: string);
var OldFN, FN: string;
begin
  if Value <> FLogDirName then
  begin
    OldFN := NormalDir(FLogDirName) + rsLogFileName;
    FN    := NormalDir(Value)       + rsLogFileName;
    StaticTextFileName.Caption :=
      MinimizeFileName(FN,
            StaticTextFileName.Width div (Canvas.TextWidth(FN) div length(FN)));
    if FileExists(OldFN) then
      MoveFile(PChar(OldFN), PChar(FN));
    FLogDirName := Value;
  end;
end;

procedure TOptionsForm.CheckBoxPersoClick(Sender: TObject);
begin
  with CheckBoxPerso do
  begin
    CheckBoxSendToTrash.Enabled    := Checked;
    CheckBoxConfirme   .Enabled    := Checked;
    RadioGroupConfirm  .Enabled    := Checked;
    CheckBoxTest       .Enabled    := Checked;
    TabSheetPerso      .TabVisible := Checked;
  end;
end;

procedure TOptionsForm.CheckBoxActiveLogClick(Sender: TObject);
begin
  with CheckBoxActiveLog do
  begin
    ButtonBrownsLog.Enabled := Checked;
    CheckBoxTime   .Enabled := Checked;
    CheckBoxSize   .Enabled := Checked;
    CheckBoxFile   .Enabled := Checked;
    CheckBoxWarning.Enabled := Checked;
    CheckBoxError  .Enabled := Checked;
    CheckBoxErase  .Enabled := Checked;
  end;
end;

procedure TOptionsForm.ButtonBrownsLogClick(Sender: TObject);
begin
  BrowseLogDlg.Selection := LogDirName;
  if BrowseLogDlg.Execute then
    LogDirName := BrowseLogDlg.Selection;
  DlgInitialization;
end;

procedure TOptionsForm.DlgInitialization;
var Arb: IArborescense;
    Msk: TMasque;
begin
  TabSheetAffichage.TabVisible := FRegistry.ApplicationInstalled;
  TabSheetService.TabVisible   := FRegistry.ServiceInstalled;
  TabSheetInfo.TabVisible      := FRegistry.Debug;
  ButtonCancel.Enabled         := not FRegistry.FirstStart;
  if not FRegistry.FirstStart then BorderIcons := BorderIcons + [biSystemMenu];
  if not Assigned(OptPageControl.ActivePage) then exit;
  case OptPageControl.ActivePage.TabIndex of
    0 : ;
    1 : begin
          StaticTextTempDir.Caption := GetTempDir;
        end;
    2 : begin
          ButtonDelLog.Enabled      := FileExists(LogFileName);
          LabelSize.Caption         := Format(LogFileSize, [SizeToStr(SizeOfFile(LogFileName))]);
          if FileExists(LogFileName) then
            RichEditLog.Lines.LoadFromFile(LogFileName)
          else
            RichEditLog.Lines.Clear;
        end;
    3 : begin
          Arb := XDLTreeView.Selected;
          Msk := XDLTreeView.MasqueSel;
          if Assigned(Arb) then
          begin
            ButtonEdit.Enabled   := (Arb.ClassTree <> ctWorkstation);
            ButtonDelete.Enabled := (Arb.ClassTree = ctDossier) or Assigned(Msk);
          end else
          begin
            ButtonEdit.Enabled   := false;
            ButtonDelete.Enabled := false;
          end;
          if Assigned(Msk) then
          begin
            if Msk.recurse  then
              LabelInfo.Caption := Format(AffMskInfo, [Msk.masque, ModeRecursif])
            else
              LabelInfo.Caption := Format(AffMskInfo, [Msk.masque, ModeStatic]);
          end else
          begin
            if not Assigned(Arb) then LabelInfo.Caption := '' else
            if Arb.ClassTree <> ctWorkstation then
              LabelInfo.Caption := Format(AffDirInfo, [Arb.Name, (Arb as IMasque).Masques.Count])
            else
              LabelInfo.Caption := Format(AffDirInfo, [Arb.Name, 0]);
          end;
          XDLTreeView.Expand(0, false);
        end;
    4 : ;
    5 : begin
          LabelInfos.Caption := Format(rsInfos, [FRegistry.AppName,
                                                 FRegistry.Version,
                                                 FRegistry.CurrVer,
                                                 FRegistry.Company,
                                                 Byte(FRegistry.FirstStart)
                                                ]);
        end;
    else ;
  end;

end;

procedure TOptionsForm.ButtonDelLogClick(Sender: TObject);
begin
  DeleteFile(LogFileName);
  DlgInitialization;
end;

procedure TOptionsForm.XDLTreeViewChange(Sender: TObject);
begin
  DlgInitialization;
end;

procedure TOptionsForm.OptPageControlChange(Sender: TObject);
begin
  DlgInitialization;
end;

procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  FRegistry := TXDELRegistry.Create;
end;

procedure TOptionsForm.FormDestroy(Sender: TObject);
begin
  FRegistry.Free;
end;

procedure TOptionsForm.ButtonDefaultClick(Sender: TObject);
begin
  FRegistry.Default;
  MiseAJour;
end;

procedure TOptionsForm.SpinEditChange(Sender: TObject);
begin
  RadioGroupClean.Items.Text := Format(rsServiceText, [SpinEditTime.Value,
                                                       SizeToStr(SpinEditSize.Value)]);
end;

procedure TOptionsForm.MiseAJour;
var I: Integer;
begin
  CheckBoxDetail         .Checked   :=  FRegistry.Affichage.Detail;
  CheckBoxIcon           .Checked   :=  FRegistry.Affichage.Minimize;
  SpinEditRefreshProgress.Value     :=  FRegistry.Affichage.Refresh;

  CheckBoxCleanTrash     .Checked   :=  FRegistry.Nettoyage.CleanTrash;
  CheckBoxCleanTemp      .Checked   :=  FRegistry.Nettoyage.CleanTemp;
  CheckBoxPerso          .Checked   :=  FRegistry.Nettoyage.CleanPerso;
  CheckBoxSendToTrash    .Checked   :=  FRegistry.Nettoyage.Send2Trash;
  CheckBoxConfirme       .Checked   :=  FRegistry.Nettoyage.Confirm;
  CheckBoxTest           .Checked   :=  FRegistry.Nettoyage.Test;
  RadioGroupConfirm      .ItemIndex :=  FRegistry.Nettoyage.ROHConfirm;

  CheckBoxActiveLog      .Checked   :=  FRegistry.Journal.JournalActive;
  CheckBoxErase          .Checked   :=  FRegistry.Journal.EraseFile;
  LogDirName                        :=  FRegistry.Journal.DirName;
  CheckBoxTime           .Checked   :=  leTimeSearch in TLogEvent(FRegistry.Journal.LogEvent);
  CheckBoxSize           .Checked   :=  leSizeFree   in TLogEvent(FRegistry.Journal.LogEvent);
  CheckBoxFile           .Checked   :=  leDeleteFile in TLogEvent(FRegistry.Journal.LogEvent);
  CheckBoxWarning        .Checked   :=  leWarning    in TLogEvent(FRegistry.Journal.LogEvent);
  CheckBoxError          .Checked   :=  leError      in TLogEvent(FRegistry.Journal.LogEvent);

  CheckBoxServiceStart   .Checked   :=  FRegistry.Service.ServiceStart;
  RadioGroupClean        .ItemIndex :=  FRegistry.Service.IndexSearch;
  SpinEditTime           .Value     :=  FRegistry.Service.FSearchSec;
  SpinEditSize           .Value     :=  FRegistry.Service.FSearchSize;

  if (FRegistry.Arbre.FStream.Size > 0) then
  begin
    FRegistry.Arbre.FStream.Seek(0, soFromBeginning);
    XDLTreeView          .LoadFromStream(FRegistry.Arbre.FStream);
  end else
  begin
    XDLTreeView.Clear;
    for I := 0 to XDLTreeView.Items.Count - 1 do
      if DriveType(XDLTreeView.Items[I].Name[1]) = Fixed then
      begin
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('*.$$$', true));
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('*.~??', true));
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('*.bak', true));
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('*.old', true));
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('*.tmp', true));
        XDLTreeView.Add(XDLTreeView.Items[I] as IMasque, TMasque.Create('file*.chk', true));
      end;
  end;
end;

procedure TOptionsForm.reMiseAJour;
begin
  FRegistry.Affichage.Detail   := CheckBoxDetail         .Checked;
  FRegistry.Affichage.Minimize := CheckBoxIcon           .Checked;
  FRegistry.Affichage.Refresh  := SpinEditRefreshProgress.Value;

  FRegistry.Nettoyage.CleanTrash := CheckBoxCleanTrash     .Checked;
  FRegistry.Nettoyage.CleanTemp  := CheckBoxCleanTemp      .Checked;
  FRegistry.Nettoyage.CleanPerso := CheckBoxPerso          .Checked;
  FRegistry.Nettoyage.Send2Trash := CheckBoxSendToTrash    .Checked;
  FRegistry.Nettoyage.Confirm    := CheckBoxConfirme       .Checked;
  FRegistry.Nettoyage.Test       := CheckBoxTest           .Checked;
  FRegistry.Nettoyage.ROHConfirm := RadioGroupConfirm      .ItemIndex;

  FRegistry.Journal.JournalActive := CheckBoxActiveLog      .Checked;
  FRegistry.Journal.EraseFile     := CheckBoxErase          .Checked;
  FRegistry.Journal.DirName       := LogDirName;
  FRegistry.Journal.LogEvent      := 0;
  if CheckBoxTime.Checked    then TLogEvent(FRegistry.Journal.LogEvent) := TLogEvent(FRegistry.Journal.LogEvent) + [leTimeSearch];
  if CheckBoxSize.Checked    then TLogEvent(FRegistry.Journal.LogEvent) := TLogEvent(FRegistry.Journal.LogEvent) + [leSizeFree];
  if CheckBoxFile.Checked    then TLogEvent(FRegistry.Journal.LogEvent) := TLogEvent(FRegistry.Journal.LogEvent) + [leDeleteFile];
  if CheckBoxWarning.Checked then TLogEvent(FRegistry.Journal.LogEvent) := TLogEvent(FRegistry.Journal.LogEvent) + [leWarning];
  if CheckBoxError.Checked   then TLogEvent(FRegistry.Journal.LogEvent) := TLogEvent(FRegistry.Journal.LogEvent) + [leError];

  FRegistry.Service.ServiceStart := CheckBoxServiceStart   .Checked;
  FRegistry.Service.IndexSearch  := RadioGroupClean        .ItemIndex;
  FRegistry.Service.FSearchSec   := SpinEditTime           .Value;
  FRegistry.Service.FSearchSize  := SpinEditSize           .Value;

  FRegistry.Arbre.FStream.Clear;
  XDLTreeView.SaveToStream(FRegistry.Arbre.FStream);
end;

procedure TOptionsForm.ButtonAddClick(Sender: TObject);
var DirName: string;
    List   : TList;
    Select : IArborescense;
begin
  DirName := '';
  List := TList.Create;
  try
    if OpenMasqueDlg(DirName, XDLTreeView.MasqueList, List, true) then
    begin
      Select := XDLTreeView.Add(DirName);
      XDLTreeView.Add(Select as IMasque, List);
    end;
  finally
    list.Free;
  end;
end;

procedure TOptionsForm.ButtonEditClick(Sender: TObject);
var DirName: string;
    List   : TList;
    I      : Integer;
    Select : IArborescense;
begin
  DirName := XDLTreeView.Selected.path;
  List := TList.Create;
  try
    Select := XDLTreeView.Selected;
    for I := 0 to (Select as IMasque).Masques.Count - 1 do
      List.Add((Select as IMasque).Masques[I]);
    if OpenMasqueDlg(DirName, XDLTreeView.MasqueList, List, false) then
    begin
      (Select as IMasque).Masques.Clear;
      XDLTreeView.Add(Select as IMasque, List);
    end;
  finally
    list.Free;
  end;
end;

procedure TOptionsForm.ButtonDeleteClick(Sender: TObject);
var Arb: IArborescense;
    Msk: TMasque;
begin
  Arb := XDLTreeView.Selected;
  Msk := XDLTreeView.MasqueSel;
  if Assigned(Msk) then
  begin
    (Arb as IMasque).Masques.Delete((Arb as IMasque).Masques.IndexOf(Msk));
    Refresh;
  end else
  begin
    XDLTreeView.Delete(Arb);
  end;
end;

end.


