unit OptionsDlg;

interface

uses Windows;

function OpenOptionsDlg(Parent: HWnd): boolean;

implementation

type
  TOpenOptionsBox = function(parent: HWnd): boolean;

const
  OptionsDLL: Longint = 0;
  ProcAddr  : TOpenOptionsBox = nil;

procedure FreeHandles;
begin
  if (@ProcAddr <> nil) then FreeLibrary(OptionsDLL);
end;

procedure InitHandles;
begin
  OptionsDLL := LoadLibrary('xdloptions.dll');
  if OptionsDLL >= HINSTANCE_ERROR then
  begin
    ProcAddr := GetProcAddress(OptionsDLL, 'OpenOptionsBox');
    if @ProcAddr = nil then
    begin
      FreeLibrary(OptionsDLL);
      OptionsDLL := 1;
    end;
  end
    else OptionsDLL := 1;
end;

function OpenOptionsDlg(Parent: HWnd): boolean;
begin
  result := false;
  if (@ProcAddr = nil) and (OptionsDLL <> 1) then InitHandles;
  if @ProcAddr <> nil then result := ProcAddr(Parent);
end;

initialization
finalization
  FreeHandles;
end.
