unit uSearch;

interface

type
{ Identifacteur d'application }

  TXDLID = string[10];

{ Ensemble des possiblit que peut faire la librairie }

             { Poubelle - Dossier temp - Personalis }
  TCanStat  = (CleanTrash, CleanTempDir, CleanPerso);
  TCanStats = set of TCanStat;

{ Function de fin de recherche }
  TEndSearchProc   = procedure(EndStat: TCanStat);
  TEndSearchProc2  = procedure(EndStat: TCanStat) of object;

{ Function de la librairie }
  TInitLibrarie      = procedure (ID, lParam, hParam: PChar);
  TFreeLibrarie      = procedure ();
  TGetNbLibrairy     = function  (): Integer;
  TLengthAppNames    = function  (): Integer;
  TGetAppNames       = procedure (Data: PChar);
  TgetSearchLists    = procedure (what: Integer; Data: PChar);
  TsetEndProc        = procedure (Value: TEndSearchProc); stdcall;
  TGetCurrentPercent = function : Real;
  TGetCurrentStatus  = function : TCanStats;
  TInitPersoTree     = function  (Data: Pointer; Size: Integer): boolean;
  TCleanWindows      = function  (what: Integer): Integer;
  TDeleteFile        = function  (const FileName: string; toTrash: boolean; deleteIfRH: boolean): integer;

  TLockLib           = function (ID: PChar): boolean;
  TUnLockLib         = function (ID: PChar): boolean;
  TIsLocked          = function : boolean;
  TNameLocked        = procedure (ID: PChar);

  TCreateFileLog     = procedure (FileName, ID, Data: PChar; Erase: boolean);

{ Function permetant de lire le pourcentage }
  TRealPercentProc = function(Percent: Real): boolean of object;

{ Differente chaine de caractre }
resourcestring
  cErrorMsg     = 'Erreur %d: %s';
  rsLogFileName = 'XDELWIN.LOG';

const
  CLEAN_TRASH_PROC    = 1001;
  CLEAN_TEMP_PROC     = 1002;
  CLEAN_PERSO_PROC    = 1003;
  CLEAN_ABORT_PROC    = 1004;

  LIST_FILE           = 1001;
  LIST_WARNING        = 1002;
  LIST_ERROR          = 1003;
  LENGTH_LIST_FILE    = 1004;
  LENGTH_LIST_WARNING = 1005;
  LENGTH_LIST_ERROR   = 1006;

const
{ Numero des erreurs }
  cThreadError  = 1001; // Erreur lors dans la recherche des fichiers dans les dossiers
  cNoLibLoad    = 1002; // Erreur lors de la lecture de la librairie
  cNoFoundFunct = 1003; // Ne peut charger la fonctions %s


const
  { Programme de recherche simple }
  XDELWINID     = 'XDL400-%3d';
  XDELWINKEY    = '--------';

implementation

end.
